﻿// --------------------------------------------------------------------------
// Copyright (c) MEMOS Software s.r.o. All rights reserved.
//
// Wake on LAN
// 
// File     : UserManagement.cs
// Author   : Lukas Neumann <lukas.neumann@memos.cz>
// Created  : 080614
//
// -------------------------------------------------------------------------- 

using System;
using System.Data;
using System.Configuration;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;

/// <summary>
/// User management class
/// </summary>
public static class UserManagement
{
    /// <summary>
    /// Returns if current user is an administrator
    /// </summary>
    /// <returns></returns>
    public static bool IsAdministrator()
    {
        string userName = HttpContext.Current.User.Identity.Name;
        return Array.IndexOf(ConfigurationManager.AppSettings["adminUsers"].Split(';'), userName) >= 0;
    }
        
}
